#include "Arduino.h"

#define ANTRIEB_WMIN 1000
#define ANTRIEB_WMITTE 1500
#define ANTRIEB_WMAX 2000
#define ANTRIEB_SCHRITTE 1000

#define ANTRIEB_BEREICH 500

//Mode 8
//Phasen- und Frequenz-korrekt
//WGM1   3 2 1 0
//       1 0 0 0
//ICR1=..... TOP
//fpwm = fclk/(2*N*TOP)
//Vorteilung
//N=8
//80Hz = 16000000/(2*8*TOP)
//TOP = 16000000/(2*8*80Hz)=12500

//dt==1000ms*(1/80Hz)/12500 == 0,001ms (1 Schritt == 0,001ms)
//=>
//1ms == 1000 Schritte
//1,5ms == 1500 Schritte
//2ms == 2000 Schritte
class Antrieb
{
    public:
        Antrieb()
        {
         
        }  

        void start()
        {
            TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (0<<COM1C1) | (0<<COM1C0) | (0<<WGM11) | (0<<WGM10);
            TCCR1B = (0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (0<<WGM12) | (0<<CS12) | (1<<CS11) | (0<<CS10); //Vort. 256, s.S. 125
       
            ICR1=12500;
       
            DDRB |= (1<<PB5); //OCR1A
            DDRB |= (1<<PB6); //OCR1B
            OCR1A = ANTRIEB_WMITTE; //PWM-Breite auf Mitte setzen.  
            OCR1B = ANTRIEB_WMITTE; //PWM-Breite auf Mitte setzen.           
        }

        //x == -500...+500        
        void links(int x)
        {
             if(x<-ANTRIEB_BEREICH)
                 x=-ANTRIEB_BEREICH;
             if(x>ANTRIEB_BEREICH)
                 x=ANTRIEB_BEREICH;
             OCR1A = ANTRIEB_WMITTE+x;
        }
        
        void rechts(int x)
        {
             if(x<-ANTRIEB_BEREICH)
                 x=-ANTRIEB_BEREICH;
             if(x>ANTRIEB_BEREICH)
                 x=ANTRIEB_BEREICH;
             OCR1B = ANTRIEB_WMITTE-x;
        }
};


